import React, { ReactElement } from 'react';
import { FlatListProps } from 'react-native';
import PageVo from './model/PageVo';
export interface ListDataHandler<L, D> {
    hasMore: (l: L) => boolean;
    getData: (l: L) => D[];
    isOk: (l: L) => boolean;
}
/**
 * 怎么处理分页参数？？
 */
export interface LoadListProps<L, D> {
    listDataHandler: ListDataHandler<L, D>;
    dataLoader: (page: PageVo) => Promise<L>;
    renderItem: ({ item, index }: {
        item: D;
        index: number;
    }) => ReactElement;
    dividerHeight?: number;
    size?: number;
    emptyConfig?: {
        hint?: string;
        builder?: React.FC;
    };
    /**
     * 是否在首次加载的时候显示loading
     * 一般情况下，加载第一页需要显示Loading。
     * 但是有些特殊情况，可能不想要这个loading（比如其它地方已经显示loading了）
     */
    showInitLoading?: boolean;
    flatListProps?: Partial<FlatListProps<D>>;
    canRefresh?: boolean;
}
export interface GJListViewRef<D> {
    refresh: (shoLoading: boolean) => void;
    changeData: (changer: (data: D[]) => D[]) => void;
}
declare module 'react' {
    function forwardRef<T, P = {}>(render: (props: P, ref: React.Ref<T>) => React.ReactElement | null): (props: P & React.RefAttributes<T>) => React.ReactElement | null;
}
declare const _default: <L, D>(props: LoadListProps<L, D> & React.RefAttributes<GJListViewRef<D>>) => React.ReactElement<any, string | React.JSXElementConstructor<any>> | null;
export default _default;
//# sourceMappingURL=LoadList.d.ts.map